package com.ylx.massage.domain.vo;

import com.alibaba.fastjson.JSONArray;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.handlers.FastjsonTypeHandler;
import com.ylx.massage.domain.TAddress;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.math.BigDecimal;

/**
 * 微信用户表
 */
@Getter
@Setter
@Accessors(chain = true)
@TableName(value = "t_wx_user",autoResultMap = true)
@ApiModel(value = "TWxUser", description = "微信用户表")
public class TWxUserVo extends TAddress implements Serializable {

    private static final long serialVersionUID = 1L;


    /**
     * 微信小程序openId
     */
    @TableField("c_openid")
    @ApiModelProperty("微信小程序openId")
    private String cOpenid;

    /**
     * 电话号码
     */
    @TableField("c_phone")
    @ApiModelProperty("电话号码")
    private String cPhone;

    /**
     * 昵称
     */
    @TableField("c_nick_name")
    @ApiModelProperty("昵称")
    private String cNickName;

    /**
     * 消费金额
     */
    @TableField("d_money")
    @ApiModelProperty("消费金额")
    private BigDecimal dMoney;

    /**
     * 下单次数
     */
    @TableField("n_num")
    @ApiModelProperty("下单次数")
    private Integer nNum;

    /**
     * 当前余额
     */
    @TableField("d_balance")
    @ApiModelProperty("当前余额")
    private BigDecimal dBalance;

    /**
     * 总收益
     */
    @TableField("d_all_money")
    @ApiModelProperty("总收益")
    private BigDecimal dAllMoney;

}
