package com.ylx.massage.service.impl;


import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ylx.common.constant.MassageConstants;
import com.ylx.common.core.domain.R;
import com.ylx.common.exception.ServiceException;
import com.ylx.massage.domain.TXiangmu;
import com.ylx.massage.mapper.TXiangmuMapper;
import com.ylx.massage.service.TXiangmuService;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.rmi.ServerException;
import java.time.LocalDateTime;

/**
 * 项目Service接口
 *
 * @author ylx
 * @date 2024-03-22
 */
@Service
public class TXiangmuServiceImpl extends ServiceImpl<TXiangmuMapper, TXiangmu> implements TXiangmuService {

    @Override
    @Transactional(rollbackFor = Exception.class)
    public Boolean addOrUpdate(TXiangmu xiangmu) {
        if (StringUtils.isBlank(xiangmu.getcId())) {
            if(StringUtils.isBlank(xiangmu.getcCover())){
                throw new ServiceException("封面图不能为空");
            }
            if(StringUtils.isBlank(xiangmu.getcTitle())){
                throw new ServiceException("标题不能为空");
            }
            if(null == xiangmu.getdPrice()){
                throw new ServiceException("标注价格（现价）不能为空");
            }
            if(null == xiangmu.getdYuanPrice()){
                throw new ServiceException("原价不能为空");
            }
            if(null == xiangmu.getnMinute()){
                throw new ServiceException("时长不能为空");
            }
            xiangmu.setnSaleNumber(MassageConstants.INTEGER_ZERO);
            xiangmu.setDtCreateTime(LocalDateTime.now());
        }
        return this.saveOrUpdate(xiangmu);
    }
}
